--==================TATUAJE=================
--ESPECIFICACION DE TATUAJE
CREATE OR REPLACE TYPE TYPE_TATOO AS OBJECT(
       codigo                    NUMBER,
       nombre                    VARCHAR2(20),
       descripcion               VARCHAR2(150),
       ruta                      VARCHAR2(40),
       MEMBER PROCEDURE mostrar);

--CUERPO DE TATUAJE
CREATE OR REPLACE TYPE BODY TYPE_TATOO AS
  MEMBER PROCEDURE mostrar IS
  BEGIN
    DBMS_OUTPUT.PUT_LINE('Código: ' || codigo || ' - ' || 'nombre: ' || nombre ||' - ' || 'descripción: ' || descripcion);
  END;
END;

--TABLA TATUAJES
CREATE TABLE TATOOS of TYPE_TATOO (PRIMARY KEY (codigo)); 

--INSERCIONES EN LA TABLA TATUAJES
INSERT INTO TATOOS VALUES(TYPE_TATOO (1, 'Calavera', 'Calavera blanca en llamas','C://tatoos//calavera.png')); 
INSERT INTO TATOOS VALUES(TYPE_TATOO (2, 'Dragon', 'Dragon estilo oriental','C://tatoos//dragon.png'));
--BLOQUE ANONIMO PARA LLAMAR EL METODO "MOSTRAR" DEL OBJETO(TEST)
DECLARE
  mi_tatoo TYPE_TATOO;
BEGIN
  SELECT VALUE(t) INTO mi_tatoo FROM TATOOS t WHERE t.codigo = 1;
  mi_tatoo.mostrar();
END;

--=================CONTRATO==================
--ESPECIFICACION DE CONTRACT
CREATE OR REPLACE TYPE OBJECT_CONTRACT AS OBJECT(
       idContract                NUMBER,
       typeContract              VARCHAR2(1),
       descripcion               VARCHAR2(150),
       dateInitial               DATE,
       dateFinish                DATE,
       MEMBER PROCEDURE mostrar);
       
--CUERPO DE CONTRACT
CREATE OR REPLACE TYPE BODY OBJECT_CONTRACT AS
  MEMBER PROCEDURE mostrar IS
  BEGIN
    DBMS_OUTPUT.PUT_LINE('Código: ' || idContract || ' - ' || 'Tipo de contrato: ' || typeContract ||' - ' || 'descripción: ' || descripcion 
                                  || 'Fecha de inicio: ' || dateInitial || ' - ' || 'Fecha final: ' || dateFinish);
  END;
END;  

--TABLA CONTRACTS
CREATE TABLE CONTRACTS of OBJECT_CONTRACT (PRIMARY KEY (idContract),
CHECK (typeContract IN ('F'/*TERMINO FIJO*/,'I'/*TERMINO INDEFINIDO*/,'S'/*PRESTACION DE SERVICIOS*/)AND typeContract = UPPER(typeContract))); 

--INSERCIONES
INSERT INTO CONTRACTS VALUES(OBJECT_CONTRACT (1, 'F', 'contrato a termino fijo',TO_DATE('2017/01/01','yyyy/mm/dd'), TO_DATE('2020-01-01','yyyy/mm/dd'))); 
INSERT INTO CONTRACTS VALUES(OBJECT_CONTRACT (2, 'I', 'contrato a termino indefinido',TO_DATE('2017/01/01','yyyy/mm/dd'), NULL)); 
--BLOQUE ANONIMO PARA LLAMAR EL METODO "MOSTRAR" DEL OBJETO(TEST)
DECLARE
  mi_contract OBJECT_CONTRACT;
BEGIN
  SELECT VALUE(t) INTO mi_contract FROM CONTRACTS t WHERE t.idContract = 1;
  mi_contract.mostrar();
END;

select * from contracts;
--===================PERSONA==========
--OBJETO PERSONA PARA HERENCIA
CREATE OR REPLACE TYPE TIPO_PERSON AS OBJECT(
       codigo                   NUMBER,
       dni                      NUMBER,
       nombre                   VARCHAR2(20),
       telefono                 NUMBER(10),
       tipo_dni                 VARCHAR2(1),
       genero                   VARCHAR2(1)
)
NOT INSTANTIABLE NOT FINAL;

--================CLIENTE==============
--OBJETO CLIENTE HEREDADO DE PERSONA
CREATE OR REPLACE TYPE TIPO_CLIENTE UNDER TIPO_PERSON(
  Informacion VARCHAR2(250)
);

--TABLA DE CLIENTES
CREATE TABLE CLIENTES OF TIPO_CLIENTE(PRIMARY KEY (CODIGO),
CHECK (GENERO IN ('F'/*FEMENINO*/,'M'/*MASCULINO*/)AND GENERO = UPPER(GENERO)),
CHECK (TIPO_DNI IN ('C'/*CEDULA DE CIUDADANIA*/,'E'/*CEDULA EXTRANJERA*/,'T'/*TARJETA DE IDENTIDAD*/)AND TIPO_DNI = UPPER(TIPO_DNI)));

--INCERSION
INSERT INTO CLIENTES VALUES(TIPO_CLIENTE (1, 1049645321, 'Pedro Hernandez',3132567840,'C','M','Piel sensible')); 
INSERT INTO CLIENTES VALUES(TIPO_CLIENTE (2, 1149312311, 'Carlos Andres',3132567840,'C','M','Piel sensible'));

--CONSULTA
select * from clientes;

--============EMPLEADO==========
--OBJETO EMPLEADO HEREDADO DE PERSONA
CREATE OR REPLACE TYPE TIPO_EMPLEADO UNDER TIPO_PERSON(
         NICK VARCHAR2(20),
         EMAIL VARCHAR2(40),
         CONTRATO REF OBJECT_CONTRACT,
         RUTA_FOTO VARCHAR2(40)
)
NOT INSTANTIABLE NOT FINAL;

--=========TATUADOR======
--TIPO TATUADOR QUE HEREDA DE EMPLEADO
CREATE OR REPLACE TYPE TIPO_TATOOARTIST UNDER TIPO_EMPLEADO(
         INFORMACION VARCHAR2(50)
);

--TABLA DE TATUADORES
CREATE TABLE TATOOARTISTS OF TIPO_TATOOARTIST(PRIMARY KEY (CODIGO),
CHECK (GENERO IN ('F'/*FEMENINO*/,'M'/*MASCULINO*/)AND GENERO = UPPER(GENERO)),
CHECK (TIPO_DNI IN ('C'/*CEDULA DE CIUDADANIA*/,'E'/*CEDULA EXTRANJERA*/,'T'/*TARJETA DE IDENTIDAD*/)AND TIPO_DNI = UPPER(TIPO_DNI)));

--INCERSION
INSERT INTO TATOOARTISTS VALUES(TIPO_TATOOARTIST (1,
 1049645321,
 'Pedro Hernandez',
 3132567840,
 'C',
 'M',
 'PELAO',
 'PELAO@GMAIL.COM',
  (SELECT REF(C) FROM CONTRACTS C WHERE C.idContract=1),
 'C://TATUADORES//PELAO.PNG',
 'CAMBIAR POR LA LISTA DE TRABAJOS'));

--CONSULTA
SELECT VALUE(T) FROM TATOOARTISTS T;

--==========================PAGO=================

--OBJETO PAYMENT
CREATE OR REPLACE TYPE TYPE_PAYMENT AS OBJECT
(
       CODIGO           NUMBER,
       FECHA            TIMESTAMP,
       PAGO             DECIMAL
);

--TABLA PAYMENT
CREATE TABLE PAYMENTS of TYPE_PAYMENT (PRIMARY KEY (CODIGO));

--INSERCION
INSERT INTO PAYMENTS VALUES(TYPE_PAYMENT (1, TO_TIMESTAMP('2017/06/04 10:13:18', 'YYYY/MM/DD HH:MI:SS'), 120000)); 
INSERT INTO PAYMENTS VALUES(TYPE_PAYMENT (2, TO_TIMESTAMP('2017/06/05 10:13:18', 'YYYY/MM/DD HH:MI:SS'), 60000));

--CONSULTA
SELECT * FROM PAYMENTS;


--==================CITA============
CREATE OR REPLACE TYPE TYPE_APPOINMENT AS OBJECT
(
       CODIGO                  NUMBER,
       FECHA_ASIGNACION        TIMESTAMP,
       FECHA_CITA              TIMESTAMP
);

--TABLA APPOINMENT
CREATE TABLE APPOINMENTS of TYPE_APPOINMENT (PRIMARY KEY (CODIGO));

--INSERCION
INSERT INTO APPOINMENTS VALUES(TYPE_APPOINMENT (1,
TO_TIMESTAMP('2017/06/04 10:13:18', 'YYYY/MM/DD HH:MI:SS'),
TO_TIMESTAMP('2017/07/04 10:13:18', 'YYYY/MM/DD HH:MI:SS'))); 

--CONSULTA
SELECT * FROM APPOINMENTS;


--================TRABAJO========
--LISTA DE PAGOS
CREATE OR REPLACE TYPE PAYMENTS_LIST IS TABLE OF REF TYPE_PAYMENT;
--LISTA DE CITAS
CREATE OR REPLACE TYPE APPOINMENTS_LIST IS TABLE OF REF TYPE_APPOINMENT;

--OBJETO TATOOWORK
CREATE OR REPLACE TYPE TYPE_TATOOWORK AS OBJECT
(
       CODIGO                  NUMBER,
       CLIENTE          REF    TIPO_CLIENTE,
       PAGOS                   PAYMENTS_LIST,
       CITAS                   APPOINMENTS_LIST,
       TATUADOR        REF     TIPO_TATOOARTIST,
       TATUAJE         REF     TYPE_TATOO,
       COSTO_TOTAL             DECIMAL,
       MEMBER FUNCTION PAGO RETURN DECIMAL, --Lo que se ha pagado
       MEMBER FUNCTION DEUDA RETURN DECIMAL  --la deuda del trabajo
);
DROP TYPE TYPE_TATOOWORK;
DROP TABLE TATOOWORKS;
--CUERPO DE TATOOWORK
CREATE OR REPLACE TYPE BODY TYPE_TATOOWORK AS
  MEMBER FUNCTION PAGO RETURN DECIMAL IS
  pagados decimal;
  BEGIN
    pagados:=0;
    for i in PAGOS.first .. pagos.last loop
      pagados:=pagados+pagos(i).pago;
    end loop;
    RETURN pagados;
  END;
  
  MEMBER FUNCTION DEUDA RETURN DECIMAL IS 
  BEGIN
    RETURN COSTO_TOTAL-PAGO();
  END;
END;


--TABLA TATOOWORKS
CREATE TABLE TATOOWORKS of TYPE_TATOOWORK (PRIMARY KEY (CODIGO))
NESTED TABLE PAGOS STORE AS PAGOS_TATOOWORK
NESTED TABLE CITAS STORE AS CITAS_TATOOWORK;

--INSERCION
INSERT INTO TATOOWORKS VALUES(TYPE_TATOOWORK (1,
(SELECT REF(C) FROM CLIENTES C WHERE C.CODIGO=1),
PAYMENTS_LIST((SELECT REF(P) FROM PAYMENTS P WHERE P.CODIGO=1)),
APPOINMENTS_LIST((SELECT REF(A) FROM APPOINMENTS A WHERE A.CODIGO=1)),
(SELECT REF(T) FROM TATOOARTISTS T WHERE T.CODIGO=1),
(SELECT REF(F) FROM TATOOS F WHERE F.CODIGO=1),
200000
));
INSERT INTO TATOOWORKS VALUES(TYPE_TATOOWORK (2,
(SELECT REF(C) FROM CLIENTES C WHERE C.CODIGO=1),
PAYMENTS_LIST((SELECT REF(P) FROM PAYMENTS P WHERE P.CODIGO=1)),
APPOINMENTS_LIST((SELECT REF(A) FROM APPOINMENTS A WHERE A.CODIGO=1)),
(SELECT REF(T) FROM TATOOARTISTS T WHERE T.CODIGO=1),
(SELECT REF(F) FROM TATOOS F WHERE F.CODIGO=2),
200000
));
INSERT INTO TATOOWORKS VALUES(TYPE_TATOOWORK (3,
(SELECT REF(C) FROM CLIENTES C WHERE C.CODIGO=2),
PAYMENTS_LIST((SELECT REF(P) FROM PAYMENTS P WHERE P.CODIGO=1),
              (SELECT REF(P) FROM PAYMENTS P WHERE P.CODIGO=2)),
APPOINMENTS_LIST((SELECT REF(A) FROM APPOINMENTS A WHERE A.CODIGO=1)),
(SELECT REF(T) FROM TATOOARTISTS T WHERE T.CODIGO=1),
(SELECT REF(F) FROM TATOOS F WHERE F.CODIGO=2),
220000
));

--CONSULTA
SELECT t.codigo, T.COSTO_TOTAL,T.PAGO(),T.DEUDA() FROM TATOOWORKS T;
SELECT * FROM TATOOWORKS;


--BLOQUE ANONIMO PARA APLICAR PAGO
DECLARE
  mi_WORK TYPE_TATOOWORK;
BEGIN
  SELECT VALUE(t) INTO mi_WORK FROM TATOOWORKS t WHERE T.CODIGO=1;
  mi_WORK.APLICAR_PAGO(90000);
END;
